org.eclipse.jgit.transport

## Class AmazonS3

- java.lang.Object
- - org.eclipse.jgit.transport.AmazonS3

    public class AmazonS3
    extends Object

A simple HTTP REST client for the Amazon S3 service.

This client uses the REST API to communicate with the Amazon S3 servers and read or write content through a bucket that the user has access to. It is a very lightweight implementation of the S3 API and therefore does not have all of the bells and whistles of popular client implementations.

Authentication is always performed using the user's AWSAccessKeyId and their private AWSSecretAccessKey.

Optional client-side encryption may be enabled if requested. The format is compatible with jets3t, a popular Java based Amazon S3 client library. Enabling encryption can hide sensitive data from the operators of the S3 service.

### Constructor Summary

Constructors
Constructor and Description
`AmazonS3(Properties props)` Create a new S3 client for the supplied user information.

### Method Summary

Methods
`OutputStream` `beginPut(String bucket, String key, ProgressMonitor monitor, String monitorTask)` Atomically create or replace a single large object.
`InputStream` `decrypt(URLConnection u)` Decrypt an input stream from `get(String, String)`.
`void` `delete(String bucket, String key)` Delete a single object.
`URLConnection` `get(String bucket, String key)` Get the content of a bucket object.
`List<String>` `list(String bucket, String prefix)` List the names of keys available within a bucket.
`void` `put(String bucket, String key, byte[] data)` Atomically create or replace a single small object.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### AmazonS3

    public AmazonS3(Properties props)

Create a new S3 client for the supplied user information.

The connection properties are a subset of those supported by the popular jets3t library. For example:

     # AWS Access and Secret Keys (required)
     accesskey: <YourAWSAccessKey>
     secretkey: <YourAWSSecretKey>

     # Access Control List setting to apply to uploads, must be one of:
     # PRIVATE, PUBLIC_READ (defaults to PRIVATE).
     acl: PRIVATE

     # Number of times to retry after internal error from S3.
     httpclient.retry-max: 3

     # End-to-end encryption (hides content from S3 owners)
     password: <encryption pass-phrase>
     crypto.algorithm: PBEWithMD5AndDES

Parameters:
  `props` - connection properties.

### Method Detail

#### get

    public URLConnection get(String bucket,
                    String key)
                      throws IOException

Get the content of a bucket object.

Parameters:
  `bucket` - name of the bucket storing the object.
  `key` - key of the object within its bucket.
Returns:
  connection to stream the content of the object. The request properties of the connection may not be modified by the caller as the request parameters have already been signed.
Throws:
  `IOException` - sending the request was not possible.

#### decrypt

    public InputStream decrypt(URLConnection u)
                        throws IOException

Decrypt an input stream from `get(String, String)`.

Parameters:
  `u` - connection previously created by `get(String, String)`}.
Returns:
  stream to read plain text from.
Throws:
  `IOException` - decryption could not be configured.

#### list

    public List<String> list(String bucket,
                    String prefix)
                      throws IOException

List the names of keys available within a bucket.

This method is primarily meant for obtaining a "recursive directory listing" rooted under the specified bucket and prefix location.

Parameters:
  `bucket` - name of the bucket whose objects should be listed.
  `prefix` - common prefix to filter the results by. Must not be null. Supplying the empty string will list all keys in the bucket. Supplying a non-empty string will act as though a trailing '/' appears in prefix, even if it does not.
Returns:
  list of keys starting with `prefix`, after removing `prefix` (or `prefix + "/"`)from all of them.
Throws:
  `IOException` - sending the request was not possible, or the response XML document could not be parsed properly.

#### delete

    public void delete(String bucket,
              String key)
                throws IOException

Delete a single object.

Deletion always succeeds, even if the object does not exist.

Parameters:
  `bucket` - name of the bucket storing the object.
  `key` - key of the object within its bucket.
Throws:
  `IOException` - deletion failed due to communications error.

#### put

    public void put(String bucket,
           String key,
           byte[] data)
             throws IOException

Atomically create or replace a single small object.

This form is only suitable for smaller contents, where the caller can reasonable fit the entire thing into memory.

End-to-end data integrity is assured by internally computing the MD5 checksum of the supplied data and transmitting the checksum along with the data itself.

Parameters:
  `bucket` - name of the bucket storing the object.
  `key` - key of the object within its bucket.
  `data` - new data content for the object. Must not be null. Zero length array will create a zero length object.
Throws:
  `IOException` - creation/updating failed due to communications error.

#### beginPut

    public OutputStream beginPut(String bucket,
                        String key,
                        ProgressMonitor monitor,
                        String monitorTask)
                          throws IOException

Atomically create or replace a single large object.

Initially the returned output stream buffers data into memory, but if the total number of written bytes starts to exceed an internal limit the data is spooled to a temporary file on the local drive.

Network transmission is attempted only when `close()` gets called at the end of output. Closing the returned stream can therefore take significant time, especially if the written content is very large.

End-to-end data integrity is assured by internally computing the MD5 checksum of the supplied data and transmitting the checksum along with the data itself.

Parameters:
  `bucket` - name of the bucket storing the object.
  `key` - key of the object within its bucket.
  `monitor` - (optional) progress monitor to post upload completion to during the stream's close method.
  `monitorTask` - (optional) task name to display during the close method.
Returns:
  a stream which accepts the new data, and transmits once closed.
Throws:
  `IOException` - if encryption was enabled it could not be configured.